## avogadrolibs 1.99.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24 FATAL_ERROR)

project(AvogadroLibs)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# Use C++17 when possible
option(PYTHON_WHEEL_BUILD "Is this a Python wheel build?" OFF)
mark_as_advanced(PYTHON_WHEEL_BUILD)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_EXTENSIONS False)
# Set symbol visibility defaults for all targets.
set(CMAKE_CXX_VISIBILITY_PRESET "hidden")
set(CMAKE_VISIBILITY_INLINES_HIDDEN True)

include(BuildType)
include(BuildLocation)
include(CompilerFlags)
include(InstallLocation)
include(DetermineVersion)

# Set up our version.
set(AvogadroLibs_VERSION_MAJOR   "1")
set(AvogadroLibs_VERSION_MINOR   "99")
set(AvogadroLibs_VERSION_PATCH   "0")
set(AvogadroLibs_VERSION
  "${AvogadroLibs_VERSION_MAJOR}.${AvogadroLibs_VERSION_MINOR}.${AvogadroLibs_VERSION_PATCH}")
find_package(Git)
determine_version(${AvogadroLibs_SOURCE_DIR} ${GIT_EXECUTABLE} "AvogadroLibs")

option(BUILD_SHARED_LIBS "Build with shared libraries" ON)

# Before any plugins are defined, and before any add_subdirectory calls:
set_property(GLOBAL PROPERTY AvogadroLibs_PLUGINS)
set_property(GLOBAL PROPERTY AvogadroLibs_STATIC_PLUGINS)

if(MSVC)
  add_definitions("-D_CRT_SECURE_NO_WARNINGS" "-DNOMINMAX -D_USE_MATH_DEFINES")
  # Ensure __cplusplus is correct, otherwise it defaults to 199711L which isn't true
  # https://docs.microsoft.com/en-us/cpp/build/reference/zc-cplusplus?view=msvc-160
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:__cplusplus")
endif()

option(ENABLE_TESTING "Enable testing and building the tests." OFF)
option(TEST_QTGL "Build the Qt OpenGL test application" OFF)
option(ENABLE_TRANSLATIONS "Enable building translations with Qt5 Linguist" OFF)
option(USE_OPENGL "Enable libraries that use OpenGL" ON)
option(USE_HDF5 "Enable optional HDF5 features" OFF)
option(USE_QT "Enable libraries that use Qt 5 or 6" ON)
option(USE_VTK "Enable libraries that use VTK" OFF)
option(USE_LIBARCHIVE "Enable optional Libarchive features" ON)
option(USE_LIBMSYM "Enable optional features using libmsym" ON)
option(USE_SPGLIB "Enable optional features using spglib" ON)
option(USE_MMTF "Enable optional features using mmtf" ON)
option(USE_PYTHON "Use Python to wrap some of our API" OFF)
option(USE_EXTERNAL_NLOHMANN "Use an externally-provided version of the nlohmann JSON library" OFF)
option(USE_EXTERNAL_PUGIXML "Use an externally-provided version of pugixml" OFF)
option(USE_EXTERNAL_STRUCT "Use an externally-provided version of the struct binary data formatting library" OFF)
set(QT_VERSION "5" CACHE STRING "What major version of Qt")
set(QT_VERSIONS_SUPPORTED 5 6)
set_property(CACHE QT_VERSION PROPERTY STRINGS 5 6)
if(NOT QT_VERSION IN_LIST QT_VERSIONS_SUPPORTED)
  message(FATAL_ERROR "Qt version must be one of ${QT_VERSIONS_SUPPORTED}")
endif()

add_subdirectory(thirdparty)
add_subdirectory(utilities)
add_subdirectory(avogadro)

if(ENABLE_TESTING)
  include(CTest)
  enable_testing()
  add_subdirectory(tests)
endif()

option(BUILD_DOCUMENTATION "Build project documentation" OFF)

if(BUILD_DOCUMENTATION)
  add_subdirectory(docs)
endif()

if(USE_PYTHON)
  add_subdirectory(python)
endif()

if(ENABLE_TRANSLATIONS)
  find_package(Qt5LinguistTools)
endif()

# SKBUILD is set for binary wheel
if (NOT SKBUILD)
  install(
    FILES
      README.md
      CONTRIBUTING.md
      LICENSE
    DESTINATION "${INSTALL_DOC_DIR}/avogadrolibs")
endif()

# After all add_subdirectory calls, so the list of plugins is complete:
get_property(AvogadroLibs_PLUGINS GLOBAL PROPERTY AvogadroLibs_PLUGINS)
get_property(AvogadroLibs_STATIC_PLUGINS GLOBAL
  PROPERTY AvogadroLibs_STATIC_PLUGINS)

configure_file(${AvogadroLibs_SOURCE_DIR}/cmake/CTestCustom.cmake.in
  ${AvogadroLibs_BINARY_DIR}/CTestCustom.cmake)

configure_file("${AvogadroLibs_SOURCE_DIR}/cmake/AvogadroLibsConfig.cmake.in"
  "${AvogadroLibs_BINARY_DIR}/AvogadroLibsConfig.cmake" @ONLY)
configure_file("${AvogadroLibs_SOURCE_DIR}/cmake/AvogadroLibsConfigVersion.cmake.in"
  "${AvogadroLibs_BINARY_DIR}/AvogadroLibsConfigVersion.cmake" @ONLY)

# SKBUILD is set for binary wheel
if (NOT SKBUILD)
  install(FILES
    "${AvogadroLibs_BINARY_DIR}/AvogadroLibsConfig.cmake"
    "${AvogadroLibs_BINARY_DIR}/AvogadroLibsConfigVersion.cmake"
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/FindEigen3.cmake"
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Findlibmsym.cmake"
    DESTINATION "${INSTALL_LIBRARY_DIR}/cmake/avogadrolibs")
  install(EXPORT "AvogadroLibsTargets"
    NAMESPACE Avogadro::
    DESTINATION "${INSTALL_LIBRARY_DIR}/cmake/avogadrolibs")
endif()

=== python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3 FATAL_ERROR)

if (NOT TARGET Avogadro::Core)
  find_package(AvogadroLibs REQUIRED)
endif()
find_package(Python COMPONENTS Interpreter Development)
set(PYBIND11_PYTHON_VERSION "3" CACHE STRING "")
set(PYBIND11_CPP_STANDARD "-std=c++17" CACHE STRING "")
find_package(pybind11 REQUIRED)

set(wrapper_SRCS
  main.cpp
  core.cpp
  io.cpp
  )

set(_python_module_install_dir "avogadro")
# SKBUILD is set for binary wheel
if (NOT SKBUILD)
  set(_python_module_install_dir "${Python_SITEARCH}/avogadro")
endif()

set(CMAKE_MODULE_LINKER_FLAGS "")
# Core
pybind11_add_module(avogadrocorepython core.cpp)
set_target_properties(avogadrocorepython
  PROPERTIES
    OUTPUT_NAME core)
target_link_libraries(avogadrocorepython
  PRIVATE
    Avogadro::Core
    pybind11::module
)

install(TARGETS avogadrocorepython LIBRARY COMPONENT python DESTINATION "${_python_module_install_dir}")

# IO
pybind11_add_module(avogadroiopython io.cpp)
set_target_properties(avogadroiopython
  PROPERTIES
    OUTPUT_NAME io)
target_link_libraries(avogadroiopython
  PRIVATE
    Avogadro::IO
    Avogadro::QuantumIO
    pybind11::module
)
install(TARGETS avogadroiopython LIBRARY COMPONENT python DESTINATION "${_python_module_install_dir}")

# Set the RPATH so the dependent libraries can be found in the wheel.
if(APPLE)
  set(_rpath_value "@loader_path")
elseif(UNIX)
  set(_rpath_value "$ORIGIN")
endif()

if (NOT WIN32)
  set_target_properties(avogadrocorepython avogadroiopython PROPERTIES
                        INSTALL_RPATH ${_rpath_value})
endif()

# Install the python files.
FILE(GLOB PY_SRCS "avogadro/*.py")
install(FILES ${PY_SRCS} COMPONENT python DESTINATION "${_python_module_install_dir}")

# Set the output directory so the python modules can be used from the build
# tree.
set_target_properties(avogadrocorepython avogadroiopython
  PROPERTIES
    ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib/avogadro"
    LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib/avogadro"
)

=== tests/CMakeLists.txt ===
include_directories("${AvogadroLibs_BINARY_DIR}/avogadro/core")

# find google test
find_package(GTest REQUIRED)
find_package(Eigen3 REQUIRED)
# Add both as "system headers" to avoid warnings generated by them with
# compilers that support that notion.
include_directories(SYSTEM
  ${GTEST_INCLUDE_DIRS}
  ${EIGEN3_INCLUDE_DIR})

include(CheckIncludeFileCXX)
include(CheckCXXSymbolExists)
check_include_file_cxx("gtest/gtest.h" HAVE_GTEST_HPP)
if(HAVE_GTEST_HPP)
  check_cxx_symbol_exists(GTEST_HAS_PTHREAD "gtest/gtest.h" GTEST_HAS_PTHREAD)
  check_cxx_symbol_exists(GTEST_IS_THREADSAFE "gtest/gtest.h" GTEST_IS_THREADSAFE)
endif()

if(GTEST_HAS_PTHREAD)
  message(STATUS "GTest claims it has pthreads, we need to link to it.")
  find_package(Threads)
  set(EXTRA_LINK_LIB ${CMAKE_THREAD_LIBS_INIT})
else()
  set(EXTRA_LINK_LIB "")
endif()

find_path(AVOGADRO_DATA_ROOT .avogadro.data
  ${AvogadroLibs_SOURCE_DIR}/../avogadrodata
  $ENV{AVOGADRO_DATA_ROOT}
  DOC "The repository for data used for testing."
  )
mark_as_advanced(AVOGADRO_DATA_ROOT)

# Add the tests for each module.
add_subdirectory(core)
add_subdirectory(io)
if(USE_QT)
  add_subdirectory(qtgui)
endif()
if(USE_OPENGL)
  add_subdirectory(rendering)
  if(USE_QT AND USE_VTK AND TEST_QTGL)
    add_subdirectory(qtopengl)
  endif()
endif()

=== avogadro/calc/CMakeLists.txt ===
add_library(Calc)

avogadro_headers(Calc
  chargemodel.h
  chargemanager.h
  defaultmodel.h
  energycalculator.h
  energymanager.h
  lennardjones.h
)

target_sources(Calc PRIVATE
  chargemodel.cpp
  chargemanager.cpp
  defaultmodel.cpp
  energycalculator.cpp
  energymanager.cpp
  lennardjones.cpp
)

avogadro_add_library(Calc)

target_link_libraries(Calc
  PUBLIC Avogadro::Core cppoptlib)

=== avogadro/io/CMakeLists.txt ===
add_library(IO)

avogadro_headers(IO
  cjsonformat.h
  cmlformat.h
  cmsgpackformat.h
  dcdformat.h
  fileformat.h
  fileformatmanager.h
  gromacsformat.h
  mdlformat.h
  vaspformat.h
  pdbformat.h
  xyzformat.h
  trrformat.h
  turbomoleformat.h
  lammpsformat.h
)

target_sources(IO PRIVATE
  cjsonformat.cpp
  cmlformat.cpp
  cmsgpackformat.cpp
  dcdformat.cpp
  fileformat.cpp
  fileformatmanager.cpp
  gromacsformat.cpp
  mdlformat.cpp
  vaspformat.cpp
  pdbformat.cpp
  xyzformat.cpp
  trrformat.cpp
  turbomoleformat.cpp
  lammpsformat.cpp
)

if(USE_HDF5)
  find_package(HDF5 REQUIRED COMPONENTS C)
  target_compile_definitions(IO PRIVATE AVO_USE_HDF5 H5_USE_110_API)
  avogadro_headers(IO hdf5dataformat.h)
  target_sources(IO PRIVATE hdf5dataformat.cpp)
  target_link_libraries(IO PRIVATE hdf5::hdf5)
endif()

if(USE_MMTF)
  find_package(MMTF REQUIRED)
  target_compile_definitions(IO PRIVATE AVO_USE_MMTF)
  avogadro_headers(IO mmtfformat.h)
  target_sources(IO PRIVATE mmtfformat.cpp)
  target_link_libraries(IO PRIVATE mmtf::mmtf)
endif()

avogadro_add_library(IO)

target_link_libraries(IO
  PUBLIC Avogadro::Core
  PRIVATE struct pugixml::pugixml nlohmann_json::nlohmann_json)
if(WIN32)
  target_link_libraries(IO PRIVATE ws2_32)
endif()

=== avogadro/qtgui/CMakeLists.txt ===
if(QT_VERSION EQUAL 6)
  find_package(Qt6 COMPONENTS Widgets Core5Compat REQUIRED)
else()
  find_package(Qt5 COMPONENTS Widgets REQUIRED)
endif()

# Provide some simple API to find the plugins, scripts, etc.
if(APPLE)
  # It is a special case, the app bundle logic breaks the relative pathing.
  add_definitions(-DAvogadroLibs_LIB_DIR=\"lib\")
  add_definitions(-DAvogadroLibs_DATA_DIR=\"share\")
else()
  add_definitions(-DAvogadroLibs_LIB_DIR=\"${INSTALL_LIBRARY_DIR}\")
  add_definitions(-DAvogadroLibs_DATA_DIR=\"${INSTALL_DATA_DIR}\")
endif()

if(USE_SPGLIB)
  add_definitions(-DUSE_SPGLIB)
endif()

# Find python for input generator scripts:
find_package(PythonInterp 3)

file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/avogadropython.h.in"
"namespace Avogadro {
static const char *pythonInterpreterPath = \"${PYTHON_EXECUTABLE}\";
}
")
configure_file("${CMAKE_CURRENT_BINARY_DIR}/avogadropython.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/avogadropython.h")

add_library(QtGui)

avogadro_headers(QtGui
  backgroundfileformat.h
  colorbutton.h
  containerwidget.h
  customelementdialog.h
  elementtranslator.h
  extensionplugin.h
  filebrowsewidget.h
  fileformatdialog.h
  generichighlighter.h
  hydrogentools.h
  insertfragmentdialog.h
  interfacescript.h
  interfacewidget.h
  jsonwidget.h
  layermodel.h
  rwlayermanager.h
  meshgenerator.h
  molecule.h
  moleculemodel.h
  multiviewwidget.h
  periodictableview.h
  persistentatom.h
  persistentbond.h
  pluginlayermanager.h
  pythonscript.h
  rwmolecule.h
  sceneplugin.h
  scenepluginmodel.h
  scriptloader.h
  sortfiltertreeproxymodel.h
  toolplugin.h
  utilities.h
  viewfactory.h
)

target_sources(QtGui PRIVATE
  backgroundfileformat.cpp
  colorbutton.cpp
  containerwidget.cpp
  customelementdialog.cpp
  elementdetail_p.cpp
  elementitem_p.cpp
  elementtranslator.cpp
  extensionplugin.cpp
  filebrowsewidget.cpp
  fileformatdialog.cpp
  generichighlighter.cpp
  hydrogentools.cpp
  insertfragmentdialog.cpp
  interfacescript.cpp
  interfacewidget.cpp
  jsonwidget.cpp
  layermodel.cpp
  rwlayermanager.cpp
  meshgenerator.cpp
  molecule.cpp
  moleculemodel.cpp
  multiviewwidget.cpp
  periodictablescene_p.cpp
  periodictableview.cpp
  pluginlayermanager.cpp
  pythonscript.cpp
  rwmolecule.cpp
  sceneplugin.cpp
  scenepluginmodel.cpp
  scriptloader.cpp
  sortfiltertreeproxymodel.cpp
  toolplugin.cpp
  utilities.cpp
  viewfactory.cpp
)

set(UIS
  customelementdialog.ui
  insertfragmentdialog.ui
)
qt_wrap_ui(UI_SOURCES ${UIS})
target_sources(QtGui PRIVATE ${UI_SOURCES})

set(RCS
  qtgui.qrc
)
qt_add_resources(RC_SOURCES ${RCS})
target_sources(QtGui PRIVATE ${RC_SOURCES})

avogadro_add_library(QtGui)
target_link_libraries(QtGui PUBLIC Avogadro::IO Qt::Widgets)
if(QT_VERSION EQUAL 6)
  target_link_libraries(QtGui PRIVATE Qt6::Core5Compat)
endif()

=== avogadro/rendering/CMakeLists.txt ===
find_package(OpenGL REQUIRED)
find_package(GLEW REQUIRED)

if(WIN32 AND NOT BUILD_SHARED_LIBS)
  add_definitions(-DGLEW_STATIC)
endif()

add_library(Rendering)

avogadro_headers(Rendering
  arcsector.h
  arcstrip.h
  arrowgeometry.h
  avogadrogl.h
  avogadrorendering.h
  beziergeometry.h
  bsplinegeometry.h
  bufferobject.h
  camera.h
  cartoongeometry.h
  curvegeometry.h
  cylindergeometry.h
  dashedlinegeometry.h
  drawable.h
  geometrynode.h
  geometryvisitor.h
  groupnode.h
  glrenderer.h
  glrendervisitor.h
  linestripgeometry.h
  meshgeometry.h
  node.h
  plyvisitor.h
  povrayvisitor.h
  primitive.h
  quad.h
  quadoutline.h
  scene.h
  shader.h
  shaderprogram.h
  solidpipeline.h
  spheregeometry.h
  textlabel2d.h
  textlabel3d.h
  textlabelbase.h
  textproperties.h
  textrenderstrategy.h
  texture2d.h
  transformnode.h
  visitor.h
  volumegeometry.h
  vrmlvisitor.h
)

target_sources(Rendering PRIVATE
  arcsector.cpp
  arcstrip.cpp
  arrowgeometry.cpp
  beziergeometry.cpp
  bufferobject.cpp
  bsplinegeometry.cpp
  cartoongeometry.cpp
  camera.cpp
  curvegeometry.cpp
  cylindergeometry.cpp
  dashedlinegeometry.cpp
  drawable.cpp
  geometrynode.cpp
  geometryvisitor.cpp
  groupnode.cpp
  glrenderer.cpp
  glrendervisitor.cpp
  linestripgeometry.cpp
  meshgeometry.cpp
  node.cpp
  plyvisitor.cpp
  povrayvisitor.cpp
  quad.cpp
  quadoutline.cpp
  scene.cpp
  shader.cpp
  shaderprogram.cpp
  solidpipeline.cpp
  spheregeometry.cpp
  textlabel2d.cpp
  textlabel3d.cpp
  textlabelbase.cpp
  textproperties.cpp
  textrenderstrategy.cpp
  texture2d.cpp
  transformnode.cpp
  visitor.cpp
  volumegeometry.cpp
  vrmlvisitor.cpp
  ambientocclusionspheregeometry.cpp
)

set(shader_files
  "arrow_vs.glsl"
  "cylinders_fs.glsl"
  "cylinders_vs.glsl"
  "dashedline_fs.glsl"
  "dashedline_vs.glsl"
  "linestrip_fs.glsl"
  "linestrip_vs.glsl"
  "mesh_fs.glsl"
  "mesh_opaque_fs.glsl"
  "mesh_vs.glsl"
  "solid_vs.glsl"
  "solid_first_fs.glsl"
  "spheres_fs.glsl"
  "spheres_vs.glsl"
  "sphere_ao_depth_vs.glsl"
  "sphere_ao_depth_fs.glsl"
  "sphere_ao_bake_vs.glsl"
  "sphere_ao_bake_fs.glsl"
  "sphere_ao_render_vs.glsl"
  "sphere_ao_render_fs.glsl"
  "textlabelbase_fs.glsl"
  "textlabelbase_vs.glsl"
)
foreach(file ${shader_files})
  get_filename_component(file_we ${file} NAME_WE)
  set(src  ${CMAKE_CURRENT_SOURCE_DIR}/${file})
  set(resh ${CMAKE_CURRENT_BINARY_DIR}/${file_we}.h)
  list(APPEND shader_h_files ${resh})
  add_custom_command(
    OUTPUT ${resh}
    DEPENDS ${src} encodefile
    COMMAND encodefile
    ARGS ${src} ${resh} ${file_we}
    COMMENT "Encoding ${src}"
    )
endforeach()
target_sources(Rendering PRIVATE
  FILE_SET shaders TYPE HEADERS
  BASE_DIRS ${CMAKE_CURRENT_BINARY_DIR}
  FILES ${shader_h_files})

avogadro_add_library(Rendering)
target_link_libraries(Rendering
  PUBLIC
    Avogadro::Headers
  PRIVATE
    Avogadro::Core # Needed for an emum in residue.h that we should move, maybe others.
    GLEW::GLEW
    OpenGL::GL)

if(USE_3DCONNEXION AND (WIN32 OR APPLE))
  target_compile_definitions(Rendering PUBLIC _3DCONNEXION)
endif()

=== avogadro/vtk/CMakeLists.txt ===
find_package(GLEW REQUIRED)

if(WIN32 AND NOT BUILD_SHARED_LIBS)
  add_definitions(-DGLEW_STATIC)
endif()

find_package(Qt${QT_VERSION} COMPONENTS Widgets REQUIRED)

find_package(VTK
  COMPONENTS
  RenderingOpenGL2 GUISupportQt DomainsChemistry
  RenderingVolumeOpenGL2 ViewsCore RenderingFreeType
  ChartsCore ViewsContext2D RenderingContextOpenGL2
  REQUIRED)

add_library(Vtk)

avogadro_headers(Vtk
  chartdialog.h
  chartwidget.h
  qvtkwidget.h
  vtkAvogadroActor.h
  vtkglwidget.h
)

target_sources(Vtk PRIVATE
  chartdialog.cpp
  chartwidget.cpp
  qvtkwidget.cpp
  vtkAvogadroActor.cpp
  vtkglwidget.cpp
)

avogadro_add_library(Vtk ${HEADERS} ${SOURCES})
set_target_properties(Vtk PROPERTIES AUTOMOC TRUE)
target_link_libraries(Vtk PUBLIC Avogadro::Rendering Avogadro::QtGui
  VTK::RenderingOpenGL2 VTK::GUISupportQt VTK::RenderingVolumeOpenGL2
  VTK::RenderingFreeType VTK::InteractionStyle VTK::ChartsCore VTK::ViewsContext2D
  VTK::RenderingContextOpenGL2 VTK::DomainsChemistryOpenGL2 Qt::Widgets
  PRIVATE GLEW::GLEW OpenGL::GL)

vtk_module_autoinit(TARGETS Vtk MODULES
  VTK::RenderingOpenGL2 VTK::GUISupportQt VTK::RenderingVolumeOpenGL2
  VTK::RenderingFreeType VTK::InteractionStyle VTK::ChartsCore VTK::ViewsContext2D
  VTK::RenderingContextOpenGL2 VTK::DomainsChemistryOpenGL2)

=== tests/qtgui/CMakeLists.txt ===
include_directories("${CMAKE_CURRENT_BINARY_DIR}"
  "${AvogadroLibs_BINARY_DIR}/avogadro/qtgui"
  "${AvogadroLibs_BINARY_DIR}/avogadro/molequeue"
  "${AvogadroLibs_SOURCE_DIR}/tests/core")

find_package(Qt5 COMPONENTS Widgets Network Test REQUIRED)

# Pull in MoleQueue for QtJson
find_package(MoleQueue REQUIRED NO_MODULE)
include_directories(${MoleQueue_INCLUDE_DIRS})

# Find python interpreter for input generator
find_package(PythonInterp 3)

# Setup config file with data location
if(AVOGADRO_DATA_ROOT)
  set(AVOGADRO_DATA ${AVOGADRO_DATA_ROOT})
endif()
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/qtguitests.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/qtguitests.h" @ONLY)

# Specify the name of each test (the Test will be appended where needed).
set(tests
  GenericHighlighter
  HydrogenTools
  # GitHub is showing this as a free() bug
  # TODO: Fix this
  # Molecule
  MoleQueueQueueListModel
  RWMolecule
  )

if(PYTHON_EXECUTABLE AND AVOGADRO_DATA)
  list(APPEND tests
# FIXME: These tests are broken
#    FileBrowseWidget
#    InputGenerator
#    InputGeneratorWidget
  )
endif()

# Build up the source file names.
set(testSrcs "")
foreach(TestName ${tests})
  message(STATUS "Adding ${TestName} test.")
  string(TOLOWER ${TestName} testname)
  list(APPEND testSrcs ${testname}test.cpp)
endforeach()

# Add a single executable for all of our tests.
add_executable(AvogadroQtGuiTests ${testSrcs})
target_link_libraries(AvogadroQtGuiTests Avogadro::QtGui Avogadro::MoleQueue
  MoleQueueClient ${GTEST_BOTH_LIBRARIES} ${EXTRA_LINK_LIB} Qt5::Widgets Qt5::Test)

# Now add all of the tests, using the gtest_filter argument so that only those
# cases are run in each test invocation.
foreach(TestName ${tests})
  add_test(NAME "QtGui-${TestName}"
    COMMAND AvogadroQtGuiTests "--gtest_filter=${TestName}Test.*")
endforeach()

=== avogadro/qtplugins/aligntool/CMakeLists.txt ===
set(aligntool_srcs
  aligntool.cpp
)

set(aligntool_uis
)

set(aligntool_rcs
  aligntool.qrc
)

avogadro_plugin(AlignTool
  "AlignTool"
  ToolPlugin
  aligntool.h
  AlignTool
  "${aligntool_srcs}"
  "${aligntool_uis}"
  "${aligntool_rcs}"
)

target_link_libraries(AlignTool PRIVATE Avogadro::QtOpenGL)

=== avogadro/qtplugins/forcefield/CMakeLists.txt ===
set(forcefield_srcs
  forcefield.cpp
  forcefielddialog.cpp
  obmmenergy.cpp
  scriptenergy.cpp
)

if (BUILD_GPL_PLUGINS)
  find_package(OpenBabel3)
  if (OpenBabel3_LIBRARY)
    list(APPEND forcefield_srcs
      obenergy.cpp
    )
    add_definitions(-DBUILD_GPL_PLUGINS)
    include_directories(${OpenBabel3_INCLUDE_DIRS} ${OpenBabel3_INCLUDE_DIR}
    ${AvogadroLibs_BINARY_DIR}/../prefix/include/openbabel3)
  endif()
endif()

avogadro_plugin(Forcefield
  "Force field optimization and dynamics"
  ExtensionPlugin
  forcefield.h
  Forcefield
  "${forcefield_srcs}"
  forcefielddialog.ui
)

target_link_libraries(Forcefield PRIVATE Avogadro::Calc)

if (BUILD_GPL_PLUGINS AND OpenBabel3_LIBRARY)
  target_link_libraries(Forcefield PRIVATE OpenBabel3)
endif()

# Bundled forcefield scripts
set(forcefields
  scripts/ani2x.py
  scripts/gfn1.py
  scripts/gfn2.py
  scripts/gfnff.py
)

if (NOT BUILD_GPL_PLUGINS)
  # install the OB / Pybel forcefield scripts
  list(APPEND forcefields
    scripts/gaff.py
    scripts/mmff94.py
    scripts/uff.py
  )
endif()

install(PROGRAMS ${forcefields}
DESTINATION "${INSTALL_LIBRARY_DIR}/avogadro2/scripts/energy/")

=== avogadro/qtplugins/insertfragment/CMakeLists.txt ===
include(ExternalProject)

avogadro_plugin(InsertFragment
  "Insert molecular fragments and crystals."
  ExtensionPlugin
  insertfragment.h
  InsertFragment
  insertfragment.cpp
)

# Install the fragments & crystals
# TODO - make this a for loop
set(_molecules "${AvogadroLibs_SOURCE_DIR}/../molecules")
set(_crystals "${AvogadroLibs_SOURCE_DIR}/../crystals")

# Look in parallel directory for the molecule fragment repository
if(NOT EXISTS "${_molecules}")
# download molecules...
ExternalProject_Add(molecules
    GIT_REPOSITORY https://github.com/openchemistry/molecules
    # or https://github.com/OpenChemistry/molecules/archive/refs/heads/master.zip
    SOURCE_DIR "${AvogadroLibs_SOURCE_DIR}/../molecules"
    CONFIGURE_COMMAND ""
    BUILD_COMMAND ""
    INSTALL_COMMAND ""
)
endif()

install(DIRECTORY "${AvogadroLibs_SOURCE_DIR}/../molecules"
  DESTINATION "${INSTALL_DATA_DIR}/avogadro2"
  PATTERN ".git" EXCLUDE
)

# crystals
if(NOT EXISTS "${_crystals}")
# download molecules... 
ExternalProject_Add(crystals
    GIT_REPOSITORY https://github.com/openchemistry/crystals
    # or https://github.com/OpenChemistry/crystals/archive/refs/heads/master.zip
    SOURCE_DIR "${AvogadroLibs_SOURCE_DIR}/../crystals"
    CONFIGURE_COMMAND ""
    BUILD_COMMAND ""
    INSTALL_COMMAND ""
)
endif()

install(DIRECTORY "${AvogadroLibs_SOURCE_DIR}/../crystals"
DESTINATION "${INSTALL_DATA_DIR}/avogadro2"
PATTERN ".git" EXCLUDE
)

=== debian/changelog ===
avogadrolibs (1.99.0-5build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:20:17 +0000

avogadrolibs (1.99.0-5build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 03:54:17 +0000

avogadrolibs (1.99.0-5) unstable; urgency=medium

  * debian patch fetch_PDB_error_check_PR1646.patch applies upstream
    PR1646 to prevent Fetch PDB segfaulting on unknown search terms.

 -- Drew Parsons <dparsons@debian.org>  Wed, 06 Mar 2024 23:38:31 +0100

avogadrolibs (1.99.0-4) unstable; urgency=medium

  * debian patch fetch_PDB_PR1642.patch applies upstream PR#1642 to
    fix fetching molecules from the PDB database.

 -- Drew Parsons <dparsons@debian.org>  Wed, 06 Mar 2024 11:33:28 +0100

avogadrolibs (1.99.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061927

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 03:05:08 +0000

avogadrolibs (1.99.0-3) unstable; urgency=medium

  * debian patch fix_startup_crash_PR1621.patch applies upstream
    PR#1621 to fix segfault when starting from the command line.

 -- Drew Parsons <dparsons@debian.org>  Sun, 18 Feb 2024 10:11:51 +0100

avogadrolibs (1.99.0-2) unstable; urgency=medium

  * Build-Depends-Indep: graphviz
    for dot, used by doxygen.
  * debian/rules: use execute_after_dh_auto* to process docs and bin
    executable installation

 -- Drew Parsons <dparsons@debian.org>  Mon, 12 Feb 2024 12:51:53 +0100

avogadrolibs (1.99.0-1) unstable; urgency=medium

  * New upstream release.
    - applies debian patches header_coreexport.patch
      and tests_include_eigen.patch
    - add fragments data as git subtree in debian/data/fragments from
      https://github.com/openchemistry/fragments
      (see avogadro/qtplugins/templatetool/CMakeLists.txt)
  * update debian/data git subtrees molecules and crystals
    - mark png files in debian/source/include-binaries
  * update debian patch qtplugins_insertfragment.patch to include
    fragments after adding set_fragments_PR1612.patch to apply
    upstream PR#1612 for fragments data dir.
  * update Build-Depends: pkg-config to pkgconf

 -- Drew Parsons <dparsons@debian.org>  Mon, 12 Feb 2024 04:14:11 +0100

avogadrolibs (1.98.1-2) unstable; urgency=medium

  * v1.98 dropped docs/conf.py. Closes: #1043909.

 -- Drew Parsons <dparsons@debian.org>  Mon, 27 Nov 2023 01:36:07 +0100

avogadrolibs (1.98.1-1) unstable; urgency=medium

  * New upstream release
    - applies debian patch fix_mouse_scroll_PR1065.patch
    - overhauls molequeue support (drop molequeue_system.patch)
  * drop debian patch manage_vtk.patch
  * add debian patches needed to run tests standalone for CI testing
    existing installation, see upstream Issue #1430.
    - tests_include_eigen.patch reinstates adding EIGEN3_INCLUDE_DIR
      when configuring tests (removed in upstream PR#1267). Use
      Eigen3::Eigen not Eigen3::Eigen3. See upstream Issue#1475.
    - header_coreexport.patch fixes include reference path to
      avogadrocoreexport.h. See upstream Issue #1476.
    - tests_find_avogadrolibs.patch ensures AvogadroLibs and Qt cmake
      configuration is loaded when configuring tests.
    - tests_skip_spacegroup_HallNumber0.patch skips SpaceGroup tests
      fillUnitCell and reduceToAsymmetricUnit which fail with Hall
      number 0. See upstream Issue #1477.

 -- Drew Parsons <dparsons@debian.org>  Mon, 27 Nov 2023 00:05:22 +0100

avogadrolibs (1.97.0-4) unstable; urgency=low

  * Team upload.
  * Trim trailing whitespace.
  * Use secure URI in Homepage field.
  * Set field Upstream-Contact in debian/copyright.
  * Set upstream metadata fields: Bug-Submit.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).
  * Update standards version to 4.6.2, no changes needed.
  * Remove field Section on binary package avogadro-utils that duplicates
    source.

 -- Andrius Merkys <merkys@debian.org>  Mon, 13 Nov 2023 13:09:06 +0000

=== debian/control ===
Source: avogadrolibs
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>
Section: science
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), cmake,
               debhelper-compat (= 13),
               dh-python,
               libarchive-dev,
               libeigen3-dev (>> 3.3),
               libgl2ps-dev,
               libglew-dev,
               libglvnd-dev,
               libhdf5-dev,
               libjs-mathjax,
               libsymspg-dev,
               molequeue, libmolequeue-dev,
               openbabel,
               pkgconf,
               python3-dev,
               python3-pybind11,
               python3-skbuild,
               python3-wheel,
               libqt5opengl5-dev,
               libqt5svg5-dev,
               qttools5-dev,
               zlib1g-dev
Build-Depends-Indep: doxygen,
 graphviz
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debichem-team/avogadrolibs
Vcs-Git: https://salsa.debian.org/debichem-team/avogadrolibs.git
Homepage: https://avogadro.cc/

Package: avogadro-utils
Architecture: any
Depends: libavogadro2-1t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: avogadro (>= 1.90)
Replaces: avogadro (<< 1.90)
Breaks: avogadro (<< 1.90)
Description: Molecular Graphics and Modelling System (library)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides avogadro utility programs:
   avobabel
   avocjsontocml
   bodrparse
   encodefile
   qube
   resdataparse

Package: libavogadro2-1t64
Provides: ${t64:Provides}
Replaces: libavogadro2-1
Breaks: libavogadro2-1 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: libavogadro-data, python3:any, python3-cclib
Description: Molecular Graphics and Modelling System (library)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the shared libraries, plugins and functionality scripts.

Package: libavogadro-dev
Architecture: any
Section: libs
Multi-Arch: same
Depends: libavogadro2-1t64 (= ${binary:Version}),
         libeigen3-dev,
         libglew-dev,
         libglvnd-dev,
         openbabel,
         ${misc:Depends}
Recommends: molequeue
Replaces: libavogadro2-1t64 (<< 1.97.0-3)
Breaks: libavogadro2-1t64 (<< 1.97.0-3)
Description: Molecular Graphics and Modelling System (development files)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the development and header files.

Package: libavogadro-data
Architecture: all
Section: libdevel
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Molecular Graphics and Modelling System (data files)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides molecule and crystal data for the
 Insert Fragment plugin.

Package: libavogadro-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-mathjax, ${misc:Depends}
Suggests: libavogadro-dev, python3-avogadro
Description: Molecular Graphics and Modelling System (lib documentation)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the documentation for libavogadro.

Package: python3-avogadro
Architecture: any
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python3:Provides}
Description: Molecular Graphics and Modelling System (Python 3 module)
 Avogadro is a molecular graphics and modelling system targeted at small
 to medium molecules.  It can visualize properties like molecular orbitals or
 electrostatic potentials and features an intuitive molecular builder.
 .
 This package provides the Python 3 module.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) -fPIC
export CFLAGS   := $(CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS := $(CPPFLAGS) $(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS  := -fPIC $(shell dpkg-buildflags --get LDFLAGS) -Wl,-z,defs -Wl,--as-needed

PYTHON3_VERSION     := $(shell py3versions -dv)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/libpython$(PYTHON3_VERSION).so),)
PYTHON3_LIBRARY=/usr/lib/$(DEB_HOST_MULTIARCH)/libpython$(PYTHON3_VERSION).so
else
PYTHON3_LIBRARY=/usr/lib/libpython$(PYTHON3_VERSION).so
endif

empty :=
space := $(empty)$(empty)

# Qt/GL support is broken on ARM, see Bug#798408
# The problem is triggered by the overlayaxes plugin
# so skip this plugin on arm.
# arm64 currently builds but that could change in the future
ARCH_NO_GL_LIST := armel armhf
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH_NO_GL_LIST)$(space)))
  OVERLAYAXES_CONFIG := -DUSE_QT_OPENGL=OFF
else
  OVERLAYAXES_CONFIG := -DUSE_QT_OPENGL=ON
endif


CMAKE_OPTS=-DUSE_HDF5=ON \
	    -DUSE_LIBMSYM=OFF \
	    -DUSE_MMTF=OFF \
	    -DOpenGL_GL_PREFERENCE=GLVND \
	    -DCMAKE_SKIP_RPATH=TRUE \
	    -DUSE_PYTHON=ON \
	    -DUSE_VTK=OFF \
	    -DENABLE_TRANSLATIONS=ON \
	    $(OVERLAYAXES_CONFIG)

%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_OPTS)

override_dh_auto_configure-indep:
	dh_auto_configure -- -DBUILD_DOCUMENTATION=ON $(CMAKE_OPTS)

execute_after_dh_auto_build-indep:
	cd obj-$(DEB_HOST_GNU_TYPE); make documentation

execute_after_dh_auto_install-arch:
	cp -r obj-$(DEB_HOST_GNU_TYPE)/bin debian/tmp/usr

execute_after_dh_auto_install-indep:
	cp -r obj-$(DEB_HOST_GNU_TYPE)/docs/html debian/tmp
